#!/usr/local/bin/perl
##############################################################################
# MP Form Mail CGI Ver4.2
# iCGI{́j
# Copyright(C) futomi 2001 - 2003
# http://www.futomi.com/
###############################################################################
use strict;
require './jcode.pl';
require './mpconfig.cgi';
use CGI;
my $q = new CGI;
$| = 1;
# X-Mailer̎w
my $X_MAILER = 'MP Form Mail CGI Ver4.2 (http://www.futomi.com/)';


# ݒt@Cǂݍ
my $MAILTO = &mpconfig::MAILTO;
my $FROM = &mpconfig::FROM;
my $REDIRECT_URL = &mpconfig::REDIRECT_URL;
my $SENDMAIL_PATH = &mpconfig::SENDMAIL;
my $SUBJECT = &mpconfig::SUBJECT;
my %NAME_MAP = &mpconfig::NAME_MAP;

my @NECESSARY_NAMES = &mpconfig::NECESSARY_NAMES;
my $CONFIRM_FLAG = &mpconfig::CONFIRM_FLAG;
my $FORMAT_CUSTOM_FLAG = &mpconfig::FORMAT_CUSTOM_FLAG;
my $REPLY_FLAG = &mpconfig::REPLY_FLAG;
my $FROM_ADDR_FOR_REPLY = &mpconfig::FROM_ADDR_FOR_REPLY;
my $SENDER_NAME_FOR_REPLY = &mpconfig::SENDER_NAME_FOR_REPLY;
my $SUBJECT_FOR_REPLY = &mpconfig::SUBJECT_FOR_REPLY;
my $ERRORS_TO = &mpconfig::ERRORS_TO;
my $ATTACHMENT_MAX_SIZE = &mpconfig::ATTACHMENT_MAX_SIZE;
my $MAX_INPUT_CHAR = &mpconfig::MAX_INPUT_CHAR;
my $LOGING_FLAG = &mpconfig::LOGING_FLAG;
my $LOGFILE = &mpconfig::LOGFILE;
my $LOG_FORMAT = &mpconfig::LOG_FORMAT;
my $DELIMITER = &mpconfig::DELIMITER;
my $SIRIAL_FLAG = &mpconfig::SIRIAL_FLAG;
my @REJECT_HOSTS = &mpconfig::REJECT_HOSTS;
my $REJECT_ERR_MSG = &mpconfig::REJECT_ERR_MSG;
my @EXT_RESTRICT = &mpconfig::EXT_RESTRICT;
my @ALLOW_FROM_URLS = &mpconfig::ALLOW_FROM_URLS;
my $WRAP = &mpconfig::WRAP;

my $MANUAL_CGIURL = &mpconfig::MANUAL_CGIURL;
my $MAIL_TEMP_FILE = &mpconfig::MAIL_TEMP_FILE;
my $CONFIRM_TEMP_FILE = &mpconfig::CONFIRM_TEMP_FILE;
my $ERROR_TEMP_FILE = &mpconfig::ERROR_TEMP_FILE;
my $ATTACHMENT_DIR = &mpconfig::ATTACHMENT_DIR;
my $REPLY_TEMP_FILE = &mpconfig::REPLY_TEMP_FILE;
my $ATTACHMENT_DEL_FLAG = &mpconfig::ATTACHMENT_DEL_FLAG;
my $REDIRECT_METHOD = &mpconfig::REDIRECT_METHOD;

my $SENDMAIL_OPT_oi = &mpconfig::SENDMAIL_OPT_oi;
my $SENDMAIL_OPT_f  = &mpconfig::SENDMAIL_OPT_f;

# mpconfig.cgi̐ݒẽ`FbN
&ConfCheck;

# OT[o̗p֎~
&ExternalRequestCheck;

# Base64GR[he[u
my $Base64Table = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'.
	           'abcdefghijklmnopqrstuvwxyz'.
	           '0123456789+/';

# wzXg̃ANZXO
my $host_name = &GetHostName($ENV{'REMOTE_ADDR'});
&RejectHostAccess($host_name);

# sendmail̃pX擾
$SENDMAIL_PATH = &MakeSendmailPath;

# tH[f[^擾,M[{AmFʗpHIDDEN^O
my @in_names = $q->param;
my @names;
my %values = ();
my @hiddens = ();
my $status = $q->param('status');


for my $key (@in_names) {
	if($key eq 'status') {next;}
	my @multi_values = $q->param($key);
	my $multi_values_num = scalar @multi_values;
	&jcode::convert(\$key, "sjis");
	my @valid_values;
	for my $value (@multi_values) {
		$value = &UnifyReturnCode($value);
		if($multi_values_num > 1) {
			if($value eq '') {
				next;
			}
		}
		#SJISpJi܂܂ĂȂΔÔ߂SJISɕϊ
		my @chars = &SpritSjisChars($value);
		unless(grep(/^[\xA1-\xDF]$/, @chars)) {
			&jcode::convert(\$value, 'sjis');
		}
		#TCY
		unless($key eq 'attachment') {
			if($MAX_INPUT_CHAR && length($value) > $MAX_INPUT_CHAR) {
				&ErrorPrint("͕́Ap$MAX_INPUT_CHAR܂łłB");
			}
		}
		my $value_for_hidden = &SecureHtml($value);
		my $hidden_tag = "<input type=\"hidden\" name=\"$key\" value=\"$value_for_hidden\">";
		push(@hiddens, $hidden_tag);
		push(@valid_values, $value);
	}
	push(@names, $key);
	$values{$key} = join(" ", @valid_values);
}
push(@hiddens, '<input type="hidden" name="status" value="1">');
# ^CX^vp̓擾
# $Stamp: Oo͗p
# $SendDate: M[p
my($stamp, $send_date) = &GetDate;
$values{'DATE'} = $send_date;
$values{'USERAGENT'} = $ENV{'HTTP_USER_AGENT'};
$values{'REMOTE_ADDR'} = $ENV{'REMOTE_ADDR'};
$values{'REMOTE_HOST'} = $host_name;


# VAԍ𐶐
if($SIRIAL_FLAG) {
	my $sirial = &MakeSirial($stamp);
	$values{'sirial'} = $sirial;
	$values{'SIRIAL'} = $sirial;
}

#Safari̕`FbN
if($ENV{'HTTP_USER_AGENT'} =~ /Safari/) {
	&SafariEncodeMistakeCheck(\%values);
}

# K{ڂI͓͂Ă邩̃`FbN
&NecessaryCheck(\%values, \@NECESSARY_NAMES);

# nameumailaddressv݂̂̂Ȃ΁AԐM̃tOOFFɂB
unless($values{'mailaddress'}) {
	$REPLY_FLAG = 0;
}

# tH[ɁAnameumailaddressv̂̂΁A
# M[AhXDIɐݒ肷B
my $from_flag = 0;
if($values{'mailaddress'} ne '') {
	$FROM = $values{'mailaddress'};
	$from_flag = 1;
}

# tH[ɁAnameusubjectv̂̂΁A
# M[TuWFNgDIɐݒ肷B
if($values{'subject'} ne '') {
	$SUBJECT = $values{'subject'};
}

# Ytt@C݂ 1 Zbg
my $attach_flag = 0;
if($q->param('attachment')) {
	$attach_flag = 1;
}

# Ytt@C΁At@C𒊏oA
# e|[t@C𐶐B
my($attach_content_type, $attache_file_name, $attach_file);
if($attach_flag) {
	my $full_file_name = $q->param('attachment');
	$attach_content_type = $q->uploadInfo($full_file_name)->{'Content-Type'};
	my $full_file_name_euc = $full_file_name;		# \ ŋ؂肽ASJISł͂܂Ȃ߁AEUCɕϊĂ \ ŕB
	&jcode::convert(\$full_file_name_euc, 'euc');
	my @path_parts = split(/\\/, $full_file_name_euc);
	$attache_file_name = pop(@path_parts);
	&jcode::convert(\$attache_file_name, 'sjis');
	# gq`FbN
	if(scalar @EXT_RESTRICT) {
		my @parts = split(/\./, $attache_file_name);
		my $ext = pop(@parts);
		unless(grep(/^$ext$/i, @EXT_RESTRICT)) {
			&ErrorPrint("w̃t@C𑗐M邱Ƃ͂ł܂B");
		}
	}
	$ATTACHMENT_DIR =~ s/\/$//;
	$attach_file = "${ATTACHMENT_DIR}/${attache_file_name}";
	open(OUTFILE, ">$attach_file") || &ErrorPrint("Ytt@C̃e|[t@C\[${attach_file}\]̍쐬Ɏs܂B:$!");
	my($bytesread, $buffer);
	while($bytesread=read($full_file_name, $buffer, 1024)) {
		print OUTFILE $buffer;
	}
	close(OUTFILE);
	# Ytt@CTCỸ`FbN
	my $attach_file_size = -s $attach_file;
	if($attach_file_size > $ATTACHMENT_MAX_SIZE) {
		unlink($attach_file);
		&ErrorPrint("$ATTACHMENT_MAX_SIZEoCgȏ̃t@C͓Ytł܂B");
	}
}

#mFʕ\
if($CONFIRM_FLAG && $attach_flag == 0 && $status eq '') {
	&PrintConfirm(\@names, \%values, \@hiddens);
	exit;
}

# tH[f[^Oɏo
if($LOGING_FLAG) {
	&Loging(\@names, \%values, $stamp);
}

#[M
&MailSend(\@names, \%values, $attach_flag, $attach_file, $attach_content_type);

# ԐM[𑗐M
if($REPLY_FLAG && $from_flag) {
	&Reply(\@names, \%values);
}

# Ytt@C폜
if($attach_flag && $ATTACHMENT_DEL_FLAG) {
	unlink($attach_file);
}

# _CNg
&Redirect;

exit;

######################################################################
# Tu[`
######################################################################

sub SafariEncodeMistakeCheck {
	#?3ȏAڂ2ڈȏ゠ꍇɁASafariۂƂ݂ȂB
	my($values_ref) = @_;
	my $count = 0;
	for my $key (keys %{$values_ref}) {
		my $value = $values_ref->{$key};
		if($value =~ /[^\x20-\x7E]/) {
			next;
		}
		if($value =~ /\?{3}/) {
			$count ++;
		}
	}
	if($count >= 2) {
		&ErrorPrint("p̃uEU[iSafarij瑗Mꂽf[^́ANĂ܂B͉ʂɖ߂Aēǂݍ݂AēxA͂ĉB");
	}
}

# K{ڂI͓͂Ă邩̃`FbN
sub NecessaryCheck {
	my($values_ref, $necessary_names_ref) = @_;
	my @null_names = ();
	my $cnt = 0;
	for my $name (@$necessary_names_ref) {
		if($values_ref->{$name} eq '') {
			push(@null_names, $name);
			$cnt ++;
		}
		if($name eq 'mailaddress') {
			unless(&MailAddressCheck($values_ref->{'mailaddress'})) {
				&ErrorPrint("$NAME_MAP{'mailaddress'}܂B");
			}
		}
	}
	my $error;
	if($cnt) {
		for my $name (@null_names) {
			if($NAME_MAP{$name} ne '') {
				$error .= 'u'.$NAME_MAP{$name}.'v';
			} else {
				$error .= 'u'.$name.'v';
			}
		}
		$error .= '͕K{ڂłB';
		&ErrorPrint($error);
	}
}

sub SpritSjisChars {
	my($string) = @_;
	$_ = $string;
	my @chars = /
		 [\x20-\x7E]             #ASCII
		|[\xA1-\xDF]             #pJ^Ji
		|[\x81-\x9F][\x40-\xFC]  #2oCg
		|[\xE0-\xEF][\x40-\xFC]  #2oCg
	/gox;
	return @chars;
}

sub Redirect {
	select(STDOUT);
	if($REDIRECT_METHOD) {
		print $q->header(-type=>'text/html; charset=Shift_JIS');
		print "<html><head><title>${X_MAILER}</title>\n";
		print "<META HTTP-EQUIV=\"Refresh\" CONTENT=\"0; URL=${REDIRECT_URL}\">\n";
		print "</head><body>\n";
		print "܂]Ȃꍇ́A<a href=\"${REDIRECT_URL}\"></a>NbNĉB";
		print "</body></html>\n";
		exit;
	} else {
		print "Location: $REDIRECT_URL\n\n";
		exit;
	}
}

# mFʂ\
sub PrintConfirm {
	my($names_ref, $values_ref, $hiddens_ref) = @_;
	# CGIURL肷B
	my $cgiurl;
	if($MANUAL_CGIURL =~ /^http/) {
		$cgiurl = $MANUAL_CGIURL;
	} else {
		$cgiurl = &GetCgiUrl;
	}
	#Hidden^O̃XJ[ϐɊi[B
	my $hidden = join("\n", @$hiddens_ref);
	#mFʃev[gǂݎ
	my $html = &ReadTemplate($CONFIRM_TEMP_FILE);
	#hidden^Ou
	if($html =~ /\$hidden\$/) {
		$html =~ s/\$hidden\$/$hidden/;
	} else {
		&ErrorPrint("mFʗpev[gHTMLt@Ci$CONFIRM_TEMP_FILEjɁA\$hidden\$ LڂĂ܂B");
	}
	$html =~ s/\$cgiurl\$/$cgiurl/;
	for my $name (@$names_ref) {
		my $disp_values = $values_ref->{$name};
		$disp_values = &SecureHtml($disp_values);
		if($disp_values eq '') {
			$disp_values = '&nbsp;';
		} else {
			$disp_values =~ s/\n/<br>\n/g;
		}
		$html =~ s/\$$name\$/$disp_values/g;
	}
	print $q->header(-type=>'text/html; charset=Shift_JIS');
	print "$html\n";
	exit;
}

# [𑗐M
sub MailSend {
	my($names_ref, $values_ref, $attach_flag, $attach_file, $attach_content_type) = @_;
	my @names = @$names_ref;
	my %values = %$values_ref;
	my $body;
	if($FORMAT_CUSTOM_FLAG) {
		$body = &MakeCustomizeMailBody(\@names, \%values);
	} else {
		$body = &MakeRegularMailBody(\@names, \%values);
	}
	# bZ[W[hbv
	if($WRAP >= 50) {
		$body = &WordWrap($body, $WRAP, 1, 1);
	}
	# bZ[WJISɕϊ
	&jcode::convert(\$body, "jis");
	my($boundary, $base64data);
	if($attach_flag) {
		# E`
		$boundary = &GenerateBoundary($body);
		#Ytt@CBase64GR[h
		my $file_size = -s "$attach_file";
		my $file_data;
		open(FILE, "$attach_file") || &ErrorPrint("Ytt@C̃e|[t@CI[vo܂łB: $!");
		sysread FILE, $file_data, $file_size;
		close(FILE);
		$base64data = &Base64Encode($file_data);
	}
	# TuWFNgɁAtH[͒lϊwqΕϊB
	for my $key (keys %$values_ref) {
		$SUBJECT =~ s/\$$key\$/$values_ref->{$key}/g;
	}
	# [^CgBase64 BGR[h
	$SUBJECT = &EncodeSubject($SUBJECT);

	# [M
	my $sendmail_opt = ' -t';
	if($SENDMAIL_OPT_oi) {
		$sendmail_opt .= ' -oi';
	}
	open(SENDMAIL, "|${SENDMAIL_PATH}${sendmail_opt}") || &ErrorPrint("[MɎs܂ : $!");
	select(SENDMAIL);
	print "To: $MAILTO\n";
	print "From: $FROM\n";
	print "Subject: $SUBJECT\n";
	print "X-Mailer: $X_MAILER\n";
	print "MIME-Version: 1.0\n";
	if($attach_flag) {
		print 'Content-Type: multipart/mixed;',"\n";
		print "	boundary=\"$boundary\"\n";
		print "Content-Transfer-Encoding: 7bit\n";
		print "\n";
		print "--$boundary\n";
	}
	print "Content-Type: text/plain\; charset=iso-2022-jp\n";
	print "Content-Transfer-Encoding: 7bit\n";
	print "\n";
	print "$body\n";
	print "\n";
	if($attach_flag) {
		my @parts = split(/\//, $attach_file);
		my $file_name = pop @parts;
		$file_name = &EncodeSubject($file_name);
		print "--$boundary\n";
		print "Content-Type: $attach_content_type; name=\"$file_name\"\n";
		print "Content-Disposition: attachment;\n";
		print " filename=\"$file_name\"\n";
		print "Content-Transfer-Encoding: base64\n";
		print "\n";
		print "$base64data\n";
		print "\n";
		print "--$boundary--";
	}
	close(SENDMAIL);
	select(STDOUT);
}

sub MakeRegularMailBody {
	my($names_ref, $values_ref) = @_;
	my $body;
	if($SIRIAL_FLAG) {
		$body = "yVAԍz\n";
		$body .= "$values_ref->{'sirial'}\n\n";
	}
	for my $name (@$names_ref) {
		if($NAME_MAP{$name}) {
			$body .= "y$NAME_MAP{$name}z\n";
		} else {
			$body .= "y$namez\n";
		}
		$body .= "$values_ref->{$name}\n";
		$body .= "\n";

	}
	$body .= "\n";
	# Mҏ[{ɒǉ
	my $host_name = &GetHostName($ENV{'REMOTE_ADDR'});

	$body .= "yMҏz\n";
	$body .= "  EuEU[      : $values_ref->{'USERAGENT'}\n";
	$body .= "  EMIPAhX: $values_ref->{'REMOTE_ADDR'}\n";
	$body .= "  EMzXg  : $values_ref->{'REMOTE_HOST'}\n";
	$body .= "  EM        : $values_ref->{'DATE'}\n";

	return $body;
}

sub MakeCustomizeMailBody {
	my($names_ref, $values_ref) = @_;
	my $template = &ReadTemplate($MAIL_TEMP_FILE);
	for my $key (@$names_ref) {
		$template =~ s/\$$key\$/$values_ref->{$key}/g;
	}
	$template =~ s/\$USERAGENT\$/$values_ref->{'USERAGENT'}/g;
	$template =~ s/\$REMOTE_ADDR\$/$values_ref->{'REMOTE_ADDR'}/g;
	$template =~ s/\$REMOTE_HOST\$/$values_ref->{'REMOTE_HOST'}/g;
	$template =~ s/\$DATE\$/$values_ref->{'DATE'}/g;
	$template =~ s/\$SIRIAL\$/$values_ref->{'SIRIAL'}/ig;
	$template = &UnifyReturnCode($template);
	return $template;
}


# tH[f[^Oɏo
sub Loging {
	my($names_ref, $values_ref, $time_stamp) = @_;
	my @log_parts;
	push(@log_parts, "${time_stamp}");;
	if($SIRIAL_FLAG) {
		push(@log_parts, "$values{'SIRIAL'}");
	}
	for my $key (@$names_ref) {
		my $part;
		if($LOG_FORMAT) {$part .= "${key}=";}
		my $value = $values_ref->{$key};
		if($DELIMITER == 2) {
			$value =~ s/ /@/g;;	#pXy[XSpXy[Xɕϊ
		} elsif($DELIMITER == 3) {
			$value =~ s/\t//g;
		} else {
			$value =~ s/,/C/g;	#pJ}SpJ}ɕϊ
		}
		$part .= "$value";
		$part = &UnifyReturnCode($part);	#sR[hu\nvɓꂷ
		$part =~ s/\n/<br>/g;				#sR[h<br>ɕϊ
		push(@log_parts, $part);
	}
	#؂蕶`
	my $delimiter_char;
	if($DELIMITER == 2) {
		$delimiter_char = ' ';
	} elsif($DELIMITER == 3) {
		$delimiter_char = "\t";
	} else {
		$delimiter_char = ",";
	}
	#O̍s𐶐
	my $log_line = join("$delimiter_char", @log_parts);
	#Ot@CI[vAbN
	open(LOGFILE, ">>$LOGFILE") || &ErrorPrint("Ot@C $LOGFILE I[vł܂łBF $!");
	if(my $lock_result = &Lock(*LOGFILE)) {
		&ErrorPrint("AݍĂ܂B΂炭Ă炨B: $lock_result");;
	}
	#sOɏo
	print LOGFILE "$log_line\n";
	close(LOGFILE);
}


# ԐM[𑗐M
sub Reply {
	my($names_ref, $values_ref) = @_;
	# ev[gt@C̕ $templateɊi[
	my $template = &ReadTemplate($REPLY_TEMP_FILE);
	# ϊ
	for my $key (@$names_ref) {
		$template =~ s/\$$key\$/$values_ref->{$key}/g;
	}

	$template =~ s/\$USERAGENT\$/$values_ref->{'USERAGENT'}/g;
	$template =~ s/\$REMOTE_ADDR\$/$values_ref->{'REMOTE_ADDR'}/g;
	$template =~ s/\$REMOTE_HOST\$/$values_ref->{'REMOTE_HOST'}/g;
	$template =~ s/\$DATE\$/$values_ref->{'DATE'}/g;
	$template =~ s/\$SIRIAL\$/$values_ref->{'SIRIAL'}/ig;

	# bZ[W̉sR[h𓝈ꂷ
	$template = &UnifyReturnCode($template);

	# bZ[W[hbv
	if($WRAP >= 50) {
		$template = &WordWrap($template, $WRAP, 1, 1);
	}
	# [M̂߂ɁAbZ[WJISɕϊ
	&jcode::convert(\$template, "jis");
	# TuWFNgɁAtH[͒lϊwqΕϊB
	for my $key (keys %$values_ref) {
		$SUBJECT_FOR_REPLY =~ s/\$$key\$/$values_ref->{$key}/g;
	}
	# TuWFNgBase64 BGR[h
	$SUBJECT_FOR_REPLY = &EncodeSubject($SUBJECT_FOR_REPLY);
	# FromsGR[h
	my $from_line = $FROM_ADDR_FOR_REPLY;
	if($SENDER_NAME_FOR_REPLY) {
		$from_line = &EncodeFrom($SENDER_NAME_FOR_REPLY, $FROM_ADDR_FOR_REPLY);
	}
	# ԐM[M
	my $sendmail_opt = ' -t';
	if($SENDMAIL_OPT_oi) {
		$sendmail_opt .= ' -oi';
	}
	if($ERRORS_TO ne '' && $SENDMAIL_OPT_f) {
		$sendmail_opt .= " -f'$ERRORS_TO'";
	}
	open(SENDMAIL, "|${SENDMAIL_PATH}${sendmail_opt}") || &ErrorPrint("ԐM[𑗐Mł܂łB: $!");
	select(SENDMAIL);
	if($ERRORS_TO ne '') {
		print SENDMAIL "Return-Path: $ERRORS_TO\n";
	}
	print "To: $FROM\n";
	print "From: $from_line\n";
	print "Subject: $SUBJECT_FOR_REPLY\n";
	print "X-Mailer: $X_MAILER\n";
	print "MIME-Version: 1.0\n";
	print "Content-Type: text/plain\; charset=iso-2022-jp\n";
	print "Content-Transfer-Encoding: 7bit\n";
	print "\n";
	print "$template";
	close(SENDMAIL);
	select(STDOUT);
}


# FromsGR[h
sub EncodeFrom {
	my($str, $from_addr) = @_;
	my $enc_str = &EncodeSubject($str);
	my @lines = split(/\n/, $enc_str);
	my $tmp = pop(@lines);
	if(length($tmp) + length($from_addr) + 3 > 75) {
		$enc_str .= "\n";
	}
	$enc_str .= " <${from_addr}>";
	return $enc_str;
}


sub ErrorPrint {
	my($msg) = @_;
	unless(-e $ERROR_TEMP_FILE) {
		&ErrorPrint2("ev[gt@C $ERROR_TEMP_FILE ܂B: $!");
	}
	my $size = -s $ERROR_TEMP_FILE;
	if(!open(FILE, "$ERROR_TEMP_FILE")) {
		&ErrorPrint2("ev[gt@C <tt>$ERROR_TEMP_FILE</tt> I[vł܂łB : $!");
		exit;
	}
	binmode(FILE);
	my $html;
	sysread(FILE, $html, $size);
	close(FILE);
	$html =~ s/\$ERROR\$/$msg/gi;
	select(STDOUT);
	print $q->header(-type=>'text/html; charset=Shift_JIS');
	print "$html\n";
	exit;
}

sub ErrorPrint2 {
	my($msg) = @_;
	select(STDOUT);
	print $q->header(-type=>'text/html; charset=Shift_JIS');
	print "$msg\n";
	exit;
}

# ݂̃^CX^vԂ
sub GetDate {
	my($sec, $min, $hour, $mday, $mon, $year, $wday) = localtime(time);
	$year += 1900;
	$mon += 1;
	$mon = sprintf("%02d", $mon);
	$mday = sprintf("%02d", $mday);
	$hour = sprintf("%02d", $hour);
	$min = sprintf("%02d", $min);
	$sec = sprintf("%02d", $sec);
	my @weekdays = ('', '', '', '', '', '', 'y');
	my $disp_stamp = "$yearN$mon$mdayi$weekdays[$wday]j $hour:$min:$sec";
	my $stamp = $year.$mon.$mday.$hour.$min.$sec;
	return $stamp,$disp_stamp;
}

# VAԍ𐶐
sub MakeSirial {
	my($stamp) = @_;
	my $sirial = "${stamp}-";
	my @IpAddr = split(/\./, $ENV{'REMOTE_ADDR'});
	for my $part (@IpAddr) {
		$part = sprintf("%03d", $part);
		$sirial .= $part;
	}
	return $sirial;
}


sub GetHostName {
	my($ip_address) = @_;
	my @addr = split(/\./, $ip_address);
	my $packed_addr = pack("C4", $addr[0], $addr[1], $addr[2], $addr[3]);
	my($name, $aliases, $addrtype, $length, @addrs);
	($name, $aliases, $addrtype, $length, @addrs) = gethostbyaddr($packed_addr, 2);
	return $name;
}

# sR[h \n ɓ
sub UnifyReturnCode {
	my($string) = @_;
	$string =~ s/\x0D\x0A/\n/g;
	$string =~ s/\x0D/\n/g;
	$string =~ s/\x0A/\n/g;
	return $string;
}

# MIME Multipartp̋E𐶐
sub GenerateBoundary {
	my($BodyString) = @_;
	my(@Lines) = split(/\n/, $BodyString);
	my($Boundary, $Buff, $i, $Line);
	my($Flag) = 1;
	while($Flag) {
		$Boundary = '';
		for ($i=0;$i<20;$i++) {
			if($i % 5 == 0 && $i != 0) {$Boundary .= '_';}
			srand;
			$Boundary .= substr($Base64Table, int(rand(60)), 1);
		}
		$Boundary .= '_'.time;
		$Flag = 0;
		for $Line (@Lines) {
			if($Line =~ /$Boundary/) {$Flag = 1; last;}
		}
	}
	return $Boundary;
}

# Ytt@CBase64GR[h
sub Base64Encode {
	my($data) = @_;
	my $table = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'.
	                 'abcdefghijklmnopqrstuvwxyz'.
	                 '0123456789+/';
	#f[^2iɕϊ
	my $binary = unpack("B*", $data);
	#pbfBOirbgǉj
	my $len = length $data;
	if($len % 3 == 1) {
		$binary .= '0000';
	} elsif($len % 3 == 2) {
		$binary .= '00';
	}
	#3oCgi24rbgjÂɕ
	my @parts24 = $binary =~ /(.{1,24})/g;
	#GR[h̃f[^i[XJ[ϐ`
	my $encoded_data;
	#oCgϊ
	for my $key (@parts24) {
		#24rbg46rbgɕ
		my @parts = $key =~ /.{6}/g;
		#ꂽ6rbgASCIIɕϊA
		#$encoded_dataɒǉ
		for my $part (@parts) {
			#6rbg10iɕϊ
			$part = sprintf("%08d", $part);
			my $dec = unpack("C", pack("B8", $part));
			#ASCIIɕϊA$encoded_dataɒǉ
			$encoded_data .= substr($table, $dec, 1);
		}
	}
	#pbfBOi"="ǉj
	if($len % 3 == 1) {
		$encoded_data .= '==';
	} elsif($len % 3 == 2) {
		$encoded_data .= '=';
	}
	#76Ő܂Ԃ悤ɉs}
	$encoded_data =~ s/(.{1,76})/$1\n/g;
	#Ō̉s菜
	$encoded_data =~ s/\n$//;
	#ʂԂ
	return $encoded_data;
}

#[TuWFNgBase64 BGR[h
sub EncodeSubject {
	my($string) = @_;
	#ASCIÎ݂ꍇɂ́AϊɕԂ
	unless($string =~ /[^\x20-\x7E]/) {
		return $string;
	}
	#pJiSpɕϊ
	&jcode::h2z_sjis(\$string);
	#ȉAASCII܂܂Ăꍇ̏
	#Shif-JIS̕ꕶAzɊi[
	my @chars = $string =~ /
		 [\x20-\x7E]             #ASCII
		|[\xA1-\xDF]             #pJ^Ji
		|[\x81-\x9F][\x40-\xFC]  #2oCg
		|[\xE0-\xEF][\x40-\xFC]  #2oCg
	/gox;
	#JISɕϊGR[h76byteȓɂȂ悤ɁA𕪊
	#Bꕶĕϊ̃oCgςĂB
	#wb_["Subject: ", "=?ISO-2022-JP?B?", "?="ŕK
	#vȂ߁A̕āAGR[h̃oCǵA49
	#oCgȓłȂ΂ȂBGR[hƁATCY4/3
	#ɑ̂ŁAtZāAJISR[h̕36oCgȓłȂ
	#΂ȂBApbfBOlƁAɁA2o
	#CgāA34oCgȓłȂ΂ȂB
	my(@lines, $line, $jis_line);
	for my $char (@chars) {
		$line .= $char;
		$jis_line = $line;
		&jcode::convert(\$jis_line, 'jis');
		if(length($jis_line) > 30) {
			push(@lines, $jis_line);
			$line = '';
			$jis_line = '';
		}
	}
	if(length($jis_line)) {
		push(@lines, $jis_line);
	}

	#sɕJISR[h̕AꂼBase64GR[h
	#wb_[ɂB
	for(my $i=0;$i<@lines;$i++) {
		my $encoded_word;
		$encoded_word .= "=?ISO-2022-JP?B?";
		$encoded_word .= &Base64Encode($lines[$i]);
		$encoded_word .= "?=";
		$lines[$i] = $encoded_word;
	}
	#sƔpXy[XŌ
	my $header = join("\n ", @lines);
	#wb_[Ԃ
	return $header;
}

sub MailAddressCheck {
	my($mail) = @_;
	#`FbNPisK؂ȕ`FbNj
	if($mail =~ /[^a-zA-Z0-9\@\.\-\_]/) {
		return 0;
	}
	#`FbNQi@}[Ñ`FbNj
	#"@"̐𐔂܂BȊOꍇɂ́A0Ԃ܂B
	my $at_num = 0;
	while($mail =~ /\@/g) {
		$at_num ++;
	}
	if($at_num != 1) {
		return 0;
	}
	#`FbNRiAJEgAhC݂̑`FbNj
	my($acnt, $domain) = split(/\@/, $mail);
	if($acnt eq '' || $domain eq '') {
		return 0;
	}
	#`FbNSihC̃hbg`FbNj
	#hbg̐𐔂܂B0ꍇɂ́A0Ԃ܂B
	my $dot_num = 0;
	while($domain =~ /\./g) {
		$dot_num ++;
	}
	if($dot_num == 0) {
		return 0;
	}
	#`FbNTihC̊ep[c`FbNj
	#擪ɃhbgȂƂ`FbN
	if($domain =~ /^\./) {
		return 0;
	}
	#ŌɃhbgȂƂ`FbN
	if($domain =~ /\.$/) {
		return 0;
	}
	#hbg2ȏ㑱ĂȂ`FbN
	if($domain =~ /\.\./) {
		return 0;
	}
	#`FbNUiTLD̃`FbNj
	my @domain_parts = split(/\./, $domain);
	my $tld = pop @domain_parts;
	if($tld =~ /[^a-zA-Z]/) {
		return 0;
	}
	#ׂẴ`FbNʂ̂ŁÃ[AhX͓K؂łB
	return 1;
}

sub Lock {
	local(*FILE) = @_;
	eval{flock(FILE, 2)};
	if($@) {
		return $!;
	} else {
		return '';
	}
}

sub GetRemoteHost {
	my($remote_host);
	if($ENV{'REMOTE_HOST'} =~ /[^0-9\.]/) {
		$remote_host = $ENV{'REMOTE_HOST'};
	} else {
		my(@addr) = split(/\./, $ENV{'REMOTE_ADDR'});
		my($packed_addr) = pack("C4", $addr[0], $addr[1], $addr[2], $addr[3]);
		my($aliases, $addrtype, $length, @addrs);
		($remote_host, $aliases, $addrtype, $length, @addrs) = gethostbyaddr($packed_addr, 2);
		unless($remote_host) {
			$remote_host = $ENV{'REMOTE_ADDR'};
		}
	}
	return $remote_host;
}

sub ConfCheck {
	unless($MAILTO) {
		&ErrorPrint("[MAhX̐ݒĉB: \$MAILTO");
	}
	unless($REDIRECT_URL) {
		&ErrorPrint("_CNgURL̐ݒĉB: \$REDIRECT_URL");
	}
	if($REPLY_FLAG) {
		unless($FROM_ADDR_FOR_REPLY) {
			&ErrorPrint("ԐM[ݒ肪ON̏ꍇɂ́AKuԐM[pM[AhXvݒ肵ĂB : \$FROM_ADDR_FOR_REPLY");
		}
		unless($SUBJECT_FOR_REPLY) {
			&ErrorPrint("ԐM[ݒ肪ON̏ꍇɂ́AKuԐM[pTuWFNgvݒ肵ĂB : \$SUBJECT_FOR_REPLY");
		}
	}
}


sub ExternalRequestCheck {
	my $url;
	if(scalar @ALLOW_FROM_URLS) {
		my $flag = 0;
		for $url (@ALLOW_FROM_URLS) {
			if($ENV{'HTTP_REFERER'} =~ /^$url/) {
				$flag = 1;
			}
		}
		unless($flag) {
			&ErrorPrint("sȃT[õNGXgłB");
		}
	}
}

sub GetCgiUrl {
	my @url_parts = split(/\//, $ENV{'SCRIPT_NAME'});
	my $script_filename = pop @url_parts;
	return $script_filename;
}

sub RejectHostAccess {
	my($HostName) = @_;
	my($Reject);
	my $RejectFlag = 0;
	if(scalar @REJECT_HOSTS) {
		for $Reject (@REJECT_HOSTS) {
			if($Reject =~ /[^0-9\.]/) {	# zXgw̏ꍇ
				if($HostName =~ /$Reject$/) {
					$RejectFlag = 1;
					last;
				}
			} else {	# IPAhXw̏ꍇ
				if($ENV{'REMOTE_ADDR'} =~ /^$Reject/) {
					$RejectFlag = 1;
					last;
				}
			}
		}
		if($RejectFlag) {
			&ErrorPrint("$REJECT_ERR_MSG");
			exit;
		}
	}
}


sub WordWrap {
	my($string, $fold_len, $european_wordwrap_flag, $kinsoku_flag) = @_;
	#s֑
	my @non_head_chars = ('A', 'B', 'C', 'D', 'E', 'H', 'I', 'J', 'K', 'R', 'S', 'T', 'U', 'X', '[', 'j', 'n', 'p', 'v', 'x', '!', ')', ',', '.', ':', ';', '?', ']', '}', '', '', '', '', '', '', '');
	#s֑
	my @non_end_chars = ('i', 'm', 'o', 'u', 'w', '(', '[', '{', '');
	#[hbvtO
	#0:sȂA1:s
	#my $european_wordwrap_flag = 1;

	my @wraped_lines;
	my @lines = split(/\n/, $string);
	for my $line (@lines) {
		if(length($line) <= $fold_len) {
			push(@wraped_lines, $line);
			next;
		}
		$_ = $line;
		my @words = /
			(?>[\x21-\x7E]+\x20)
			|(?>[\x21-\x7E]+)
			|(?>[\xA1-\xDF]+\x20)
			|(?>[\xA1-\xDF]+)
			|(?>(?>[\x81-\x9F][\x40-\xFC]|[\xE0-\xEF][\x40-\xFC])+\x20)
			|(?>(?>[\x81-\x9F][\x40-\xFC]|[\xE0-\xEF][\x40-\xFC])+)
			|(?>\x20+)
		/gox;

		my $wraped_line;
		my $wraped_line_len;
		for my $word (@words) {
			my $word_len = length($word);
			if($wraped_line_len + $word_len < $fold_len) {
				$wraped_line .= $word;
				$wraped_line_len += $word_len;
			} elsif($wraped_line_len + $word_len == $fold_len) {
				push(@wraped_lines, "${wraped_line}${word}");
				$wraped_line = '';
				$wraped_line_len = 0;
			} else {
				if($european_wordwrap_flag && $word !~ /[^\x20-\x7E]/ && $word_len < $fold_len) {
					push(@wraped_lines, "${wraped_line}");
					$wraped_line = $word;
					$wraped_line_len = $word_len;
				} else {
					$_ = $word;
					my @chars = /
						 [\x20-\x7E]             #ASCII
						|[\xA1-\xDF]             #pJ^Ji
						|[\x81-\x9F][\x40-\xFC]  #2oCg
						|[\xE0-\xEF][\x40-\xFC]  #2oCg
					/gox;
					for my $char (@chars) {
						if($kinsoku_flag && $wraped_line_len == 0 && grep(/^\Q$char\E$/, @non_head_chars)) {
							my $line_num = scalar @wraped_lines;
							$wraped_lines[$line_num - 1] .= $char;
							next;
						}
						my $char_len = length($char);
						if($wraped_line_len + $char_len < $fold_len) {
							$wraped_line .= $char;
							$wraped_line_len += $char_len;
						} elsif($wraped_line_len + $char_len == $fold_len) {
							if($kinsoku_flag && grep(/^\Q$char\E$/, @non_end_chars)) {
								push(@wraped_lines, "${wraped_line}");
								$wraped_line = $char;
								$wraped_line_len = $char_len;
							} else {
								push(@wraped_lines, "${wraped_line}${char}");
								$wraped_line = '';
								$wraped_line_len = 0;
							}
						} else {
							my($line_end_char) = $wraped_line =~ /(
								[\x21-\x7E]
								|[\xA1-\xDF]
								|[\x81-\x9F][\x40-\xFC]
								|[\xE0-\xEF][\x40-\xFC]
							)$/ox;
							if($kinsoku_flag && grep(/^\Q$char\E$/, @non_head_chars)) {
								push(@wraped_lines, "${wraped_line}${char}");
								$wraped_line = '';
								$wraped_line_len = 0;
							} elsif($kinsoku_flag && grep(/^\Q$line_end_char\E$/, @non_end_chars)) {
								$wraped_line =~ s/\Q${line_end_char}\E$//;
								push(@wraped_lines, "${wraped_line}");
								$wraped_line = "${line_end_char}${char}";
								$wraped_line_len = length($wraped_line);
							} else {
								push(@wraped_lines, "${wraped_line}");
								$wraped_line = $char;
								$wraped_line_len = $char_len;
							}
						}
					}
				}
			}
		}
		push(@wraped_lines, "${wraped_line}");
	}
	my $wraped_string = join("\n", @wraped_lines);
	return $wraped_string;
}

sub SecureHtml {
	my($html) = @_;
	$html =~ s/\&amp;/\&/g;
	$html =~ s/\&/&amp;/g;
	$html =~ s/\"/&quot;/g;
	$html =~ s/</&lt;/g;
	$html =~ s/>/&gt;/g;
	return $html;
}


sub ReadTemplate {
	my($file) = @_;
	my $size = -s $file;
	if(!open(FILE, "$file")) {
		my $disp_file = &SecureHtml($file);
		&ErrorPrint("ev[gt@C $disp_file I[vł܂łB: $!");
	}
	binmode(FILE);	# For Windows
	my $str;
	sysread(FILE, $str, $size);
	close(FILE);
	$str = &UnifyReturnCode($str);
	return $str;
}

sub GetCommandPath {
	my($command) = @_;
	my @pathes;
	if($command eq '') {return @pathes;}
	if($^O =~ /MSWin32/i) {
		return @pathes;
	}
	my @whereis_list = ('whereis', '/usr/bin/whereis', '/usr/ucb/whereis');
	for my $whereis (@whereis_list) {
		my $res = `$whereis $command`;
		if($res eq '') {
			next;
		} else {
			my @locations = split(/\s/, $res);
			for my $path (@locations) {
				if($path =~ /$command$/) {
					push(@pathes, $path);
				}
			}
			last;
		}
	}
	my $num = scalar @pathes;
	unless($num) {
		my $path = `which $command`;
		if($path =~ /$command$/) {
			push(@pathes, $path);
		}
	}
	return @pathes;
}

sub MakeSendmailPath {
	my $path;
	if($SENDMAIL_PATH eq '') {
		($path) = &GetCommandPath('sendmail');
		if($path eq '') {
			&ErrorPrint("sendmail̃pX擾ł܂łBݒt@CɖIɎw肵ĉB");
		}
	} else {
		$path = $SENDMAIL_PATH;
	}
	return $path;
}

